﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace CodeGarage.it.Euro2012.Domain.Services
{
    public class MatchScheduleServices:IMatchScheduleServices
    {
        private string _dataSource;

        private MatchScheduleServices() { }

        public MatchScheduleServices(string dataSource)
        {
            _dataSource = dataSource;
        }
                
        public List<Team> GetTeams()
        {
            string fileName = string.Format(@"{0}\Cache\GetTeams.txt", _dataSource);

            using (System.IO.StreamReader r = new System.IO.StreamReader(fileName))
            {
                return JsonConvert.DeserializeObject<List<Team>>(r.ReadToEnd());
            }
 
        }

        public List<MatchDay> GetFullSchedule()
        {
            string fileName = string.Format(@"{0}\Cache\FullSchedule.txt", _dataSource);

            using (System.IO.StreamReader r = new System.IO.StreamReader(fileName))
            {
                return JsonConvert.DeserializeObject<List<MatchDay>>(r.ReadToEnd());
            }
 
        }

        public List<MatchDay> GetMatchDay(DateTime date)
        {
            string fileName = string.Format(@"{0}\Cache\FullSchedule.txt", _dataSource);

            using (System.IO.StreamReader r = new System.IO.StreamReader(fileName))
            {
                return JsonConvert.DeserializeObject<List<MatchDay>>(r.ReadToEnd());
            }
 
        }

      
    }
}
