﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace CodeGarage.it.Euro2012.Web.Mobile.Controllers
{
    public class ResourcesController : Controller
    {
        //
        // GET: /Resources/

        public ManifestResult Manifest()
        {
            var pages = new List<string>();
            pages.Add(Url.Action("Index", "Home"));
            pages.Add(Url.Action("Index", "Teams"));
 
            
            var cacheSection = new List<string>();
            cacheSection.AddRange(pages);
            cacheSection.AddRange(GetRelativePathsToRoot("~/Scripts/"));
            cacheSection.AddRange(GetRelativePathsToRoot("~/Css/"));
            cacheSection.AddRange(GetRelativePathsToRoot("~/Content/"));

            //uncomment followin line to get manifest error
            //cacheSection.Add("TestError.txt");

            var manifestResult = new ManifestResult("1.0.0")
            {
                CacheSection = cacheSection,
                NetworkSection = new string[] { "*" }
            };

            return manifestResult;
        }

        private IEnumerable<string> GetRelativePathsToRoot(string virtualPath)
        {
            var physicalPath = Server.MapPath(virtualPath);
            var absolutePaths = Directory.GetFiles(physicalPath, "*.*", SearchOption.AllDirectories);

            return absolutePaths.Select(
                x => Url.Content(virtualPath + x.Replace(physicalPath, ""))
            );
        }
        

    }
}
