﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using CodeGarage.it.Euro2012.Domain;
using CodeGarage.it.Euro2012.Domain.Services;
using CodeGarage.it.Euro2012.Web.Mobile.Models;

namespace CodeGarage.it.Euro2012.Web.Mobile.Controllers
{
    public class ScheduleController : Controller
    {
      
        public JsonResult UpcomingMatches() 
        {
            IMatchScheduleServices service = new MatchScheduleServices(HttpContext.Server.MapPath("~/App_Data"));
            ScheduleViewModel model = new ScheduleViewModel();
            model.Days = new List<MatchDayDTO>();
            MatchDay day = service.GetMatchDay(DateTime.Now).First();
            MatchDayDTO dto = new MatchDayDTO(){DayType = day.DayType.ToString(), Name = day.Name };
            
            dto.Matches = new List<MatchDTO>();

            foreach (var m in day.Matches)
            {
                dto.Matches.Add(new MatchDTO()
                {
                    Description =string.Format("{0} - {1}", m.HostTeam.ShortName, m.GuestTeam.ShortName),
                    Location = string.Format("{0} {1} {2}", m.Location.Name, m.Location.City, m.Location.Country),
                    LocalTime = m.DayAndLocalTime.ToShortTimeString(),
                    GuestTeam = new TeamDTO()
                    {
                        Name = m.HostTeam.Name,
                        ShortName = m.HostTeam.ShortName
                    },
                    HostTeam = new TeamDTO()
                    {
                        Name = m.GuestTeam.Name,
                        ShortName = m.GuestTeam.ShortName
                    }
                });
            }

            return Json(dto, JsonRequestBehavior.AllowGet);           

        }  

    }
}
