﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using CodeGarage.it.Euro2012.Domain;
using CodeGarage.it.Euro2012.Domain.Services;
using CodeGarage.it.Euro2012.Web.Mobile.Models;

namespace CodeGarage.it.Euro2012.Web.Mobile.Controllers
{
    public class TeamsController : Controller
    {
        //
        // GET: /Teams/

        public ActionResult Index()
        {
            IMatchScheduleServices service = new MatchScheduleServices(HttpContext.Server.MapPath("~/App_Data"));
            TeamsViewModel model = new TeamsViewModel();

            model.TeamGroups = new List<TeamGroupDTO>();

            TeamGroupDTO currentGroup = null;

            foreach (var team in service.GetTeams().OrderBy(t => t.Group))
            {
                if (currentGroup == null || currentGroup.Name != team.Group)
                {
                    currentGroup = new TeamGroupDTO();
                    currentGroup.Teams = new List<TeamDTO>();
                    currentGroup.Name = team.Group;
                    model.TeamGroups.Add(currentGroup);
                }
                
                currentGroup.Teams.Add(new TeamDTO() { Name = team.Name, ShortName = team.ShortName });             

            }

            return View(model);
        }

        public ActionResult Details(string teamShortName)
        {
            IMatchScheduleServices service = new MatchScheduleServices(HttpContext.Server.MapPath("App_Data"));
            TeamsViewModel model = new TeamsViewModel();
            return View(model);
        }



    }
}
