﻿// <author>Andrea Colaci</author>
// <email>CodeGarage.it</email>
// <date>May 2012</date>
// <summary>Contains data manipulation scripts</summary>

function ShowMatchDay() {

    var rawData = window.localStorage.getItem("MatchDay");

    if (rawData != undefined && rawData != null) {

        ko.applyBindings(MatchDayViewModel(JSON.parse(rawData)));
    
    }
    else {

        $.ajax("/Schedule/UpcomingMatches",
           {
               type: "POST",
               dataType: "json",
               complete: function (response) {
                   rawData = response.responseText;
                   window.localStorage.setItem("MatchDay", rawData);
                   ko.applyBindings(MatchDayViewModel(JSON.parse(rawData)));
               }
           });

    }
}

function MatchDayViewModel(data)
{
    var self = this;
    self.Day = ko.observable(data);
    self.Matches = ko.observableArray(data.Matches);
    //Computed
    self.Title = ko.computed(function () {
        return this.Day().Name + ":" ;
    }, this);
}


