﻿// <author>Andrea Colaci</author>
// <email>CodeGarage.it</email>
// <date>May 2012</date>
// <summary>Contains offline management scripts</summary>

var manifestResourceCount = 0;
var resourceDownloadedCount = 0;

$(window).bind("online offline", function (event) {

    //alert(navigator.onLine ? "Online" : "Offline");
});

$(window.applicationCache).bind("checking", function (e) {
    //Looking for a new manifest...
    $("#updateStatus").text("Checking...");
    resourceDownloadedCount = 0;
    manifestResourceCount = GetManifestResourceCount()
});

$(window.applicationCache).bind("downloading", function (e) {
    //browser has started resources listed in manifest
    $("#updateStatus").text("Downloading...");
});

$(window.applicationCache).bind("progress", function (e) {
    //fired after every resource was successfully downloaded
    resourceDownloadedCount++;
    if (manifestResourceCount > 0) {
        $("#updateStatus").text("Downloading (" + Math.floor(resourceDownloadedCount * 100 / manifestResourceCount) + "\%)");
    }
});

$(window.applicationCache).bind("cached",  function (e) {
    //Great! We've finished downloading all resources
    $("#updateStatus").text("Cached");
});

$(window.applicationCache).bind("noupdate",  function (e) {
    //Manifes is the same on both server and client (device)
    $("#updateStatus").text("No updates available.");
});

$(window.applicationCache).bind("obsolete", function (e) {
    //invalid manifest, webApp deleted from storage, no more available from offline
});

$(window.applicationCache).bind("updateready", function (e) {
    //Reload needed to show/use new resources
    $("#updateStatus").text("Update success, reload...");
   
    $('#btnReload').live('click', function () {
        window.applicationCache.swapCache();
        window.location.reload();
    });

    $('#btnCancelReload').live('click', function () {
        $.mobile.changePage($('#About'), { transition: "pop", reverse: true });
    });

    $.mobile.changePage($('#UpdateDialog'), { transition: "pop", changeHash: false, role:"dialog"});
});

$(window.applicationCache).bind("error", function (e) {
    //Error during resource download, check manifest content!
    $("#updateStatus").text("ERROR!");
});

// I get the total number of files in the cache manifest.
// I do this by manually parsing the manifest file.
function GetManifestResourceCount() {
    $.ajax({
        type: "get",
        url: "/offline.appcache",
        dataType: "text",
        cache: false,
        success: function (content) {
            // Strip out the non-cache sections.
            content = content.replace(new RegExp("(NETWORK|FALLBACK):((?!(NETWORK|FALLBACK|CACHE):)[\\w\\W]*)","gi"),"");

            // Strip out all comments.
            content = content.replace(new RegExp("#[^\\r\\n]*(\\r\\n?|\\n)", "g"),"");

            // Strip out the cache manifest header and
            // trailing slashes.
            content = content.replace(new RegExp("CACHE MANIFEST\\s*|\\s*$", "g"),"");

            // Strip out extra line breaks and replace with
            // a hash sign that we can break on.
            content = content.replace(new RegExp("[\\r\\n]+", "g"),"#");

            // Get the total number of files.
            var totalFiles = content.split("#").length-1;

            manifestResourceCount = totalFiles;
        }
    });
}
